<template>
  <div style="wight:100%;height:100%;">
    <div :id="`mars3d-container${mapKey}`"
    :class="['mars3d-container', customClass, { 'mars3d-container-compare-rh' : compare }]"></div>
  </div>

</template>

<script>
import Vue from 'vue'
import { Tools, HttpReq, CAMap} from '@/assets/js/common.js';

// 使用免费开源版本
import 'mars3d/dist/mars3d.css'
import * as mars3d from 'mars3d'
import * as Cesium from 'mars3d-cesium/Build/Cesium/Cesium'
import  { initGraphicManager,initLayerManager,bindLayerContextMenu } from './js/graphicManager'


// 导入插件(其他插件类似，插件清单访问：http://mars3d.cn/dev/guide/start/install.html)
// echarts插件
// import 'mars3d-echarts'

// 为了方便使用,绑定到原型链，在其他vue文件，直接 this.mars3d 来使用
Vue.prototype.mars3d = mars3d
Vue.prototype.Cesium = mars3d.Cesium

var map;
let pathEntity = null;
export default {
  name: 'mars3dViewer',
  
  mounted(){
    this.getCoordinate('','',120);
  },

  data(){
    return{
      historyTrajectoryData:[],
      deviceId:'DESKTOP-L56LKGM',
      zuobianData:[],
      toJavaCoordinates:[],
      weilanName:[],
      carNumber:'',
      carPlaySpeed:5,
    }
  },

  props: {
    // 初始化配置参数
    url: String,

    // 地图唯一性标识
    mapKey: {
      type: String,
      default: ''
    },

    // 自定义参数
    options: Object,

    // 是否分屏显示
    compare: {
      type: Boolean,
      default: false
    },

    // 是否插入到body元素上
    appendToBody: {
      type: Boolean,
      default: false
    },

    // 自定义css类名
    customClass: {
      type: String,
      default: ''
    }
  },

  destroy() {
    this[`map${this.mapKey}`].destroy()
    delete this[`map${this.mapKey}`]
  },

  methods: {
    //获取数据
    getCoordinate(equipmentName,number,speed,bTime,eTime) {
      let that = this;
      that.deviceId = equipmentName;
      that.carNumber = number;
      that.carPlaySpeed = speed;
      //获取历史轨迹
      if(number == ''){
        // this.$nextTick(()=>{
        //   if (this.appendToBody) {
        //     document.body.appendChild(this.$el)
        //   }
        //    if (this.mapKey) {
        //     this.initMars3d(this.options)
        //   } else {
        //     mars3d.Resource.fetchJson({ url: this.url }).then((data) => {
        //       this.initMars3d(data.map3d)// 构建地图
        //     })
        //   }
        // })
      }else{
        if(that.deviceId == '' || that.deviceId == undefined){
          this.$notify({
						title: '暂无轨迹数据！',
						type: 'warning',
						duration: 2500
					});
        }else{
          HttpReq.truckDispatching.getAllHistroyCarTrajectoryQuery({name:that.deviceId,bTime:bTime,eTime:eTime}).then((res) => {
            //console.log('获取历史轨迹',res);
            if(res.code == 200){
              if(res.data.line.length == 0){
                this.$notify({
                  title: '暂无轨迹数据！',
                  type: 'warning',
                  duration: 2500
                });
              }else{

                let obj1 = {};
                let array1 = [];
                res.data.line.forEach((item,index)=>{
                  let array2 = [];
                  array2.push(item.lon);
                  array2.push(item.lat);
                  array2.push(1000);
                  array1.push(array2);
                })
                obj1.name = res.data.name;
                obj1.arrays = array1;
                //let hisCenterData = [...that.historyTrajectoryData];
                let hisCenterData = [];
                hisCenterData.push(obj1);
                that.historyTrajectoryData = [...hisCenterData];

                this.$nextTick(()=>{
                  if (this.appendToBody) {
                    document.body.appendChild(this.$el)
                  }
                  if (this.mapKey) {
                    this.initMars3d(this.options)
                  } else {
                    mars3d.Resource.fetchJson({ url: this.url }).then((data) => {
                      this.initMars3d(data.map3d)// 构建地图
                    })
                  }
                })

              }
            }
          })
        }
        
      }
      
    },
    //创建地图电子围栏
    initMars3d(options) {
      let that = this;
      //if (this[`map${this.mapKey}`]) return

      const mapOptions = {
        ...options,
        ...this.options,
        control: {
          defaultContextMenu: false, //右键菜单
        },
      }

      // 创建三维地球场景
      map = new mars3d.Map(`mars3d-container${this.mapKey}`, mapOptions)
      this[`map${this.mapKey}`] = map

      //历史轨迹回放
      that.historyTrajectoryData.forEach(function(item,index){
        var graphicLayer2 = new mars3d.layer.GraphicLayer();
        map.addLayer(graphicLayer2);
        var itemText = `<table style="width: auto;">
                <tr>
                  <th scope="col" colspan="2" style="text-align:center;font-size:15px;">卡车号码：${that.carNumber}</th>
                </tr>
                <tr>
                  <td>设备名称：${that.deviceId}</td>
                </tr>
              </table>`;
        initGraphicManager(graphicLayer2,itemText);
        that.addGraphic_02(graphicLayer2,item.arrays,that.carNumber);
      })
     
      // 抛出事件
      this.$emit('onload', map)
    },
    //车辆轨迹1
    addGraphic_02(graphicLayer2,positions,truckName) {
        let that = this;
        var property = new Cesium.SampledPositionProperty();
        var tempTime;
        
        //起点
        tempTime = map.clock.currentTime; //开始时间
        property.addSample(tempTime, Cesium.Cartesian3.fromDegrees(positions[0][0],positions[0][1],positions[0][2]));
        for(let i = 1;i < positions.length;i++){
          tempTime = Cesium.JulianDate.addSeconds(tempTime, that.carPlaySpeed, new Cesium.JulianDate());
          property.addSample(tempTime, Cesium.Cartesian3.fromDegrees(positions[i][0],positions[i][1],positions[i][2],));
        }

        var graphic = new mars3d.graphic.PathEntity({
          position: property,
          style: {
            width: 3,
            color: "#8a2e3b",
            opacity: 1.0,
            leadTime: 0, // 前方的路线不显示
            //高亮时的样式（默认为鼠标移入，也可以指定type:'click'单击高亮），构造后也可以openHighlight、closeHighlight方法来手动调用
            highlight: {
              type: mars3d.EventType.click,
              color: "#ff0000",
            },
          },
          label: {
            text: truckName,
            font_size: 22,
            font_family: "楷体",
            color: "#ff0000",
            color: Cesium.Color.AZURE,
            outline: true,
            outlineColor: Cesium.Color.BLACK,
            outlineWidth: 2,
            horizontalOrigin: Cesium.HorizontalOrigin.CENTER,
            verticalOrigin: Cesium.VerticalOrigin.BOTTOM,
            pixelOffset: new Cesium.Cartesian2(10, -25), //偏移量
          },
          model: {
            url: '//data.mars3d.cn/gltf/mars/car/tufangche.glb',
            scale: 1,
            minimumPixelSize: 50,
          },
        });
        graphicLayer2.addGraphic(graphic); //还可以另外一种写法: graphic.addTo(graphicLayer)

    },
    //车辆轨迹2
    initPath(data,graphicLayer2,positions,truckName) {
      const property = new Cesium.SampledPositionProperty()
      property.forwardExtrapolationType = Cesium.ExtrapolationType.HOLD

      let start;
      let stop;
      for (let i = 0, len = data.length; i < len; i++) {
        const item = data[i]
        const lng = Number(item.x.toFixed(6)) // 经度
        const lat = Number(item.y.toFixed(6)) // 纬度
        const height = item.z // 高度
        const time = item.time // 时间

        let position = null
        if (lng && lat) {
          position = Cesium.Cartesian3.fromDegrees(lng, lat, height)
        }
        let juliaDate = null
        if (time) {
          juliaDate = Cesium.JulianDate.fromIso8601(time)
        }
        if (position && juliaDate) {
          property.addSample(juliaDate, position)
        }

        if (i === 0) {
          start = juliaDate
        } else if (i === len - 1) {
          stop = juliaDate
        }

      }

      // 设置时钟属性
      map.clock.startTime = start.clone()
      map.clock.stopTime = stop.clone()
      map.clock.currentTime = start.clone()
      map.clock.clockRange = Cesium.ClockRange.LOOP_STOP
      map.clock.multiplier = 5

      if (map.controls.timeline) {
        map.controls.timeline.zoomTo(start, stop)
      }

      // 创建path对象
      pathEntity = new mars3d.graphic.PathEntity({
        position: property,
        orientation: new Cesium.VelocityOrientationProperty(property),
        style: {
          width: 3,
          color: "#ff0000",
          opacity: 1.0,
          leadTime: 0, // 前方的路线不显示
        },
        label: {
          text: truckName,
          font_size: 22,
          font_family: "楷体",
          color: "#ff0000",
          outline: true,
          outlineColor: Cesium.Color.BLACK,
          outlineWidth: 2,
          horizontalOrigin: Cesium.HorizontalOrigin.CENTER,
          verticalOrigin: Cesium.VerticalOrigin.BOTTOM,
          pixelOffset: new Cesium.Cartesian2(10, -25) // 偏移量
        },
        model: {
          url: '//data.mars3d.cn/gltf/mars/car/tufangche.glb',
          scale: 1,
          minimumPixelSize: 50,
        },
      })
      graphicLayer2.addGraphic(pathEntity)
    },
    getSampledPositionProperty(points){
      let property = new Cesium.SampledPositionProperty();
      let start = this.map.clock.currentTime;
      let positions = mars3d.LatLngArray.toCartesians(points);
      for (let i = 0; i < positions.length; i++) {
        let time = Cesium.JulianDate.addSeconds(start, i * 20, new Cesium.JulianDate());
        let position = positions[i];
        property.addSample(time, position);
      }
      return property;
    },
   
  }
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style >
.cesium-viewer-toolbar{
  
  display: none !important;
}
.mars3d-compass{
  display: none !important;
}
.mars3d-locationbar{
  display: none !important;
}
.mars3d-distance-legend{
  display: none !important;
}
.mars3d-container {
  height: 100%;
  width: 100vw;
  overflow: hidden;
}

/* 重写Cesium的css */

/**cesium按钮背景色*/
.cesium-button {
  background-color: #3f4854;
  color: #e6e6e6;
  fill: #e6e6e6;
  box-shadow: 0 1px 4px rgba(0, 0, 0, 0.3);
  line-height: 32px;
}

.cesium-viewer-geocoderContainer .cesium-geocoder-input {
  background-color: rgba(63, 72, 84, 0.7);
}

.cesium-viewer-geocoderContainer .cesium-geocoder-input:focus {
  background-color: rgba(63, 72, 84, 0.9);
}

.cesium-viewer-geocoderContainer .search-results {
  background-color: #3f4854;
}

.cesium-geocoder-searchButton {
  background-color: #3f4854;
}

.cesium-infoBox-title {
  background-color: #3f4854;
}

.cesium-infoBox {
  background: rgba(63, 72, 84, 0.9);
}

.cesium-toolbar-button img {
  height: 100%;
}

.cesium-performanceDisplay-defaultContainer {
  top: auto;
  bottom: 35px;
  right: 50px;
}
.cesium-performanceDisplay-ms,
.cesium-performanceDisplay-fps {
  color: #fff;
}

/**cesium工具栏位置*/
.cesium-viewer-toolbar {
  top: auto;
  left: auto;
  right: 12px;
  bottom: 35px;
}

.cesium-viewer-toolbar > .cesium-toolbar-button,
.cesium-navigationHelpButton-wrapper,
.cesium-viewer-geocoderContainer {
  margin-bottom: 5px;
  float: right;
  clear: both;
  text-align: center;
}

.cesium-baseLayerPicker-dropDown {
  bottom: 0;
  right: 40px;
  max-height: 700px;
  margin-bottom: 5px;
}

.cesium-navigation-help {
  top: auto;
  bottom: 0;
  right: 40px;
  transform-origin: right bottom;
}

.cesium-sceneModePicker-wrapper {
  width: auto;
}

.cesium-sceneModePicker-wrapper .cesium-sceneModePicker-dropDown-icon {
  float: left;
  margin: 0 3px;
}

.cesium-viewer-geocoderContainer .search-results {
  left: 0;
  right: 40px;
  width: auto;
  position: absolute;
  z-index: 999;
}

.cesium-infoBox-title {
  background-color: #3f4854;
}

.cesium-infoBox {
  top: 50px;
  background: rgba(63, 72, 84, 0.9);
}

/**左下工具栏菜单*/
.toolbar-dropdown-menu-div {
  background: rgba(43, 44, 47, 0.8);
  border: 1px solid #2b2c2f;
  z-index: 999;
  position: absolute;
  right: 60px;
  bottom: 40px;
  display: none;
}

.toolbar-dropdown-menu {
  min-width: 110px;
  padding: 0;
}
.toolbar-dropdown-menu > li {
  padding: 0 3px;
  margin: 2px 0;
}
.toolbar-dropdown-menu > li > a {
  color: #edffff;
  display: block;
  padding: 4px 10px;
  clear: both;
  font-weight: normal;
  line-height: 1.6;
  white-space: nowrap;
  text-decoration: none;
}

.toolbar-dropdown-menu > li > a:hover,
.dropdown-menu > li > a:focus {
  color: #fff;
  background-color: #444d59;
}

.toolbar-dropdown-menu > .active > a,
.dropdown-menu > .active > a:hover,
.dropdown-menu > .active > a:focus {
  color: #fff;
  background-color: #444d59;
}

.toolbar-dropdown-menu i {
  padding-right: 5px;
}

.infoview{
  position: absolute;
  top: 100px;
  left: 500px;
  width: 50vw;
  z-index: 1000;
}
</style>
